﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace RC522
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

        }

        private void READ_Click(object sender, EventArgs e)
        {
            int i, j, sector;

            READbox.Text = "";
            READbox.Update();
            READ.Enabled = false;
            string str = "";

            Byte[] OUTBuffer = new byte[65];    //Allocate a memory buffer equal to the OUT endpoint size + 1
            Byte[] INBuffer = new byte[65];     //Allocate a memory buffer equal to the IN endpoint size + 1
            uint BytesWritten = 0;
            uint BytesRead = 0;

            // Store card_data in PIC
            OUTBuffer[0] = 0x00;    //The first byte is the "Report ID" and does not get sent over the USB bus.  Always set = 0.
            OUTBuffer[1] = (byte)'d';
            hidComponent1.WriteRead(OUTBuffer, BytesWritten, INBuffer, BytesRead);

            // Tagtype
            OUTBuffer[1] = (byte)'t';
            hidComponent1.WriteRead(OUTBuffer, BytesWritten, INBuffer, BytesRead);
            READbox.Text += "Tag type :";
            for (i = 0; i < 2; i++)
                READbox.Text += string.Format("{0:X2} ", INBuffer[i]);
            READbox.Text += "\r\n\r\n";

            // UID
            OUTBuffer[1] = (byte)'u';
            hidComponent1.WriteRead(OUTBuffer, BytesWritten, INBuffer, BytesRead);
            READbox.Text += "NUID :";
            for (i = 0; i < 4; i++)
                READbox.Text += string.Format("{0:X2} ", INBuffer[i]);
            READbox.Text += "\r\n\r\n";

            // DATA
            READbox.Text += "Sector Block   0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15  AccessBits\r\n\r\n";

            for (sector = 0; sector < 16; sector++)
            {

                OUTBuffer[1] = (byte)'s';
                OUTBuffer[2] = (byte)sector;

                hidComponent1.WriteRead(OUTBuffer, BytesWritten, INBuffer, BytesRead);


                int[] c1 = new int[4];
                c1[0] = (INBuffer[55] & 0x10) >> 4;
                c1[1] = (INBuffer[55] & 0x20) >> 5;
                c1[2] = (INBuffer[55] & 0x40) >> 6;
                c1[3] = (INBuffer[55] & 0x60) >> 7;
                int[] c2 = new int[4];
                c2[0] = (INBuffer[56] & 0x01);
                c2[1] = (INBuffer[56] & 0x02) >> 1;
                c2[2] = (INBuffer[56] & 0x04) >> 2;
                c2[3] = (INBuffer[56] & 0x08) >> 3;
                int[] c3 = new int[4];
                c3[0] = (INBuffer[56] & 0x10) >> 4;
                c3[1] = (INBuffer[56] & 0x20) >> 5;
                c3[2] = (INBuffer[56] & 0x40) >> 6;
                c3[3] = (INBuffer[56] & 0x80) >> 7;


                str = string.Format("  {0:D2}  ", sector);

                for (i = 0; i < 4; i++)
                {
                    if (i != 0) str += "      ";

                    str += string.Format("   {0:D2}   ", i);

                    for (j = 0; j < 16; j++)
                    {
                        str += string.Format("{0:X2} ", INBuffer[j + 16 * i]);

                    }

                    str += string.Format(" [{0:D1}, {1:D1}, {2:D1}]", c1[i], c2[i], c3[i]);
                    str += "\r\n";
                }
                str += "\r\n";

                READbox.Text += str;
            }

            OUTBuffer[1] = (byte)'e';
            hidComponent1.WriteRead(OUTBuffer, BytesWritten, INBuffer, BytesRead);


            //Dump of error codes
            for (i = 0; i < 64; i++)
            {
                if (INBuffer[i] == 0) break;
                else str += ((char)INBuffer[i]).ToString();
            }
            READbox.Text += str;
            //End: Dump of error codes

            READ.Enabled = true;

        }
    }
}
